; 
    .model small,c
    .386
    .stack
    include support.asm
    CRC16 PROTO :WORD,:WORD
.data 
    sample db "my other brother darryl",0,0
.code
    .startup

    push  40h
    pop   es
    mov   bx,6ch
    mov   esi,es:[bx]
    mov   ecx,1000000
  @@:
    invoke CRC16,OFFSET sample,LENGTHOF sample    
    dec   ecx
    jnz   @B
    mov   edx,es:[bx]
    sub   edx,esi
    invoke dw2dec,edx,ADDR outBuf
    print NL,"elapsed ticks = ",ADDR outBuf,NL    

    print NL,"Press any normal key to exit...",NL
    call waitkey
    .exit
; 
; This proc uses the 16-bit CRC-CCITT polynomial
; x^16 + x^12 + x^5 + 1 (truncated value = 1021h).
; Per the CCITT recommendation, it uses no reflection,
; an intitial register value of FFFFh, and skips the
; XOR of the final register value.
; 
; * The caller must augment the message with 16 zero
; bits (two zero bytes) *
; 
CRC16 proc uses bx cx dx si pMessage:WORD,messageLength:WORD

    POLY     EQU 1021h
    INIT     EQU 0FFFFh
   
    mov   si,pMessage
    mov   cx,messageLength

    ; Use DX for the working register.
    mov   dx,INIT

  byteLoop:
    ; Load the next byte into AL.
    mov   al,[si]
    ; Start of unrolled bit loop.
    REPEAT 8
      ; Shift the next bit of the byte into bit0 of AH.
      shl   ax,1
      ; Clear all but bit0 of AH.
      and   ah,1
      ; Shift the working register.
      shl   dx,1
      ; The shifted-out bit is now in CF.
      ; If it was 0, then skip the XOR.
      jnc   @F
      ; Move the bit into bit0 of the working register.
      or    dl,ah
      ; XOR with the poly.
      xor   dx,POLY
      ; Clear AH so the next OR operation will not affect
      ; the value in the working register.
      mov   ah,0
    @@:
      ; Move the bit into bit0 of the working register.
      or    dl,ah
    ENDM
    inc   si
    dec   cx
    jnz   byteLoop
   
    ; Return CRC value in AX.
    mov   ax,dx
    ret
CRC16 endp
; 
end
